# Snapshot report for `test/llms/parse-output.test.ts`

The actual snapshot is saved in `parse-output.test.ts.snap`.

Generated by [AVA](https://avajs.dev).

## parseArrayOutput - handles valid arrays correctly

> should return [1, 2, 3] for "[1,2,3]"

    [
      1,
      2,
      3,
    ]

> should return ["a", "b", "c"] for "["a", "b", "c"]

    [
      'a',
      'b',
      'c',
    ]

> should return [{"a": 1}, {"b": 2}] for [{"a": 1}, {"b": 2}]

    [
      {
        a: 1,
      },
      {
        b: 2,
      },
    ]

## parseArrayOutput - handles arrays surrounded by text correctly

> should return [1, 2, 3] for "The array is [1,2,3]"

    [
      1,
      2,
      3,
    ]

> should return ["a", "b", "c"] for "Array: ["a", "b", "c"]. That's all!"

    [
      'a',
      'b',
      'c',
    ]

> should return [{"a": 1}, {"b": 2}] for "This is the array [{"a": 1}, {"b": 2}] in the text"

    [
      {
        a: 1,
      },
      {
        b: 2,
      },
    ]

## parseArrayOutput - throws error for invalid arrays

> Snapshot 1

    'Invalid JSON array: not a valid array'

## parseObjectOutput - handles valid objects correctly

> should return {"a":1,"b":2,"c":3} for {"a":1,"b":2,"c":3}

    {
      a: 1,
      b: 2,
      c: 3,
    }

> should return {"name":"John","age":30,"city":"New York"} for {"name":"John","age":30,"city":"New York"}

    {
      age: 30,
      city: 'New York',
      name: 'John',
    }

## parseObjectOutput - handles objects surrounded by text correctly

> should return {"a":1,"b":2,"c":3} for "The object is {"a":1,"b":2,"c":3}"

    {
      a: 1,
      b: 2,
      c: 3,
    }

> should return {"name":"John","age":30,"city":"New York"} for "Object: {"name":"John","age":30,"city":"New York"}. That's all!"

    {
      age: 30,
      city: 'New York',
      name: 'John',
    }

## parseObjectOutput - handles JSON array of objects

> should return first object {"a":1,"b":2} for [{"a":1,"b":2},{"c":3,"d":4}]

    {
      a: 1,
      b: 2,
    }

## parseObjectOutput - throws error for invalid objects

> Snapshot 1

    'Invalid JSON object: not a valid object'

## parseBooleanOutput - handles `true` outputs correctly

> should return true for "True"

    true

> should return true for "TRUE"

    true

> should return true for "true."

    true

## parseBooleanOutput - handles `false` outputs correctly

> should return false for "False"

    false

> should return false for "FALSE"

    false

> should return false for "false!"

    false

## parseBooleanOutput - throws error for invalid outputs

> Snapshot 1

    'Invalid boolean output: notbooleanvalue'

## parseNumberOutput - handles integer outputs correctly

> should return 42 for "42"

    42

> should return -5 for "  -5 "

    -5

## parseNumberOutput - handles float outputs correctly

> should return 42.42 for "42.42"

    42.42

> should return -5.5 for "   -5.5 "

    -5.5

## parseNumberOutput - throws error for invalid outputs

> Snapshot 1

    'Invalid number output: NotANumber'

## parseOutput - handles arrays correctly

> should parse and return [1, 2, 3] for "[1, 2, 3]"

    [
      1,
      2,
      3,
    ]

## parseOutput - handles objects correctly

> should parse and return {"a": 1, "b": "two"} for "{"a": 1, "b": "two"}"

    {
      a: 1,
      b: 'two',
    }

## parseOutput - handles booleans correctly

> should parse and return true for "True"

    true

## parseOutput - handles numbers correctly

> should parse and return 123.45 for "123.45"

    123.45

## parseOutput - throws error for invalid data

> Snapshot 1

    'Invalid number output: not a number'
